<?php
namespace App\Controllers\V2;

use App\Controllers\BaseController;
use App\Models\common\CodeModel;
use App\Models\v2\M710Model;

class M710 extends BaseController
{
    private $model, $codeModel;

    public function __construct()
    {
        $this->model = new M710Model();
        $this->codeModel = new CodeModel();
    }

    public function lists(): string
    {
        $codes = $this->codeModel->getCodeLists(['STEP_VERIFICATION', 'VRFCREQ_WAY', 'CP_ID', 'ARTICLE_TYPE']); // 코드조회
        $sido = $this->model->getAreaList(); // 지역조회
        $bonbu = $this->model->getBonbuList();
        $team = $this->model->getTeamList();
        $user = $this->model->getUserList();

        $this->data['sido'] = $sido;
        $this->data['bonbu'] = $bonbu;
        $this->data['team'] = $team;
        $this->data['user'] = $user;
        $this->data['codes'] = $codes;

        return view("pages/v2/m710/lists", $this->data);
    }

    public function getResultList()
    {
        $start = (int) $this->request->getGet('start') ?: 0;
        $end = (int) $this->request->getGet('length') ?: 10;

        $data = [
            'atcl_no' => $this->request->getGet('atcl_no'), // 매물번호
            'stat_cd' => $this->request->getGet('stat_cd'), // 현재상태
            'realtor_nm' => $this->request->getGet('realtor_nm'), // 중개소
            'charger_gbn' => $this->request->getGet('charger_gbn'), // 배정여부
            'assign_yn' => $this->request->getGet('assign_yn'), // 배정여부2
            'receipt_sdate' => $this->request->getGet('receipt_sdate'), // 접수기간1
            'receipt_edate' => $this->request->getGet('receipt_edate'), // 접수기간2
            'complete_sdate' => $this->request->getGet('complete_sdate'), // 완료기간1
            'complete_edate' => $this->request->getGet('complete_edate'), // 완료기간2
            'srcSido' => $this->request->getGet('srcSido'), // 시도
            'srcGugun' => $this->request->getGet('srcGugun'), // 시군구
            'srcDong' => $this->request->getGet('srcDong'), // 읍면동
            'bonbu' => $this->request->getGet('bonbu'), // 본부
            'team' => $this->request->getGet('team'), // 팀
            'damdang' => $this->request->getGet('damdang'), // 담당
            'vrfcreq_way' => $this->request->getGet('vrfcreq_way'), // 검증방식1
            'vrfc_type_sub' => $this->request->getGet('vrfc_type_sub'), // 검증방식2
            'rcpt_cpid' => $this->request->getGet('rcpt_cpid'), // 매체사
            'rlet_type_cd' => $this->request->getGet('rlet_type_cd'), // 매물종류
            'status' => $this->request->getGet('status'), // 전송여부
        ];

        $totalCount = $this->model->getTotalCount($data);


        $datas = $this->model->getResultList($start, $end, $data);

        return $this->response->setJSON(body: [
            'recordsTotal' => $totalCount,
            'recordsFiltered' => $totalCount,
            'data' => $datas,
        ]);
    }


    public function getExcelList()
    {
        try {

            $data = [
                'atcl_no' => $this->request->getGet('atcl_no'), // 매물번호
                'stat_cd' => $this->request->getGet('stat_cd'), // 현재상태
                'realtor_nm' => $this->request->getGet('realtor_nm'), // 중개소
                'charger_gbn' => $this->request->getGet('charger_gbn'), // 배정여부
                'assign_yn' => $this->request->getGet('assign_yn'), // 배정여부2
                'receipt_sdate' => $this->request->getGet('receipt_sdate'), // 접수기간1
                'receipt_edate' => $this->request->getGet('receipt_edate'), // 접수기간2
                'complete_sdate' => $this->request->getGet('complete_sdate'), // 완료기간1
                'complete_edate' => $this->request->getGet('complete_edate'), // 완료기간2
                'srcSido' => $this->request->getGet('srcSido'), // 시도
                'srcGugun' => $this->request->getGet('srcGugun'), // 시군구
                'srcDong' => $this->request->getGet('srcDong'), // 읍면동
                'bonbu' => $this->request->getGet('bonbu'), // 본부
                'team' => $this->request->getGet('team'), // 팀
                'damdang' => $this->request->getGet('damdang'), // 담당
                'vrfcreq_way' => $this->request->getGet('vrfcreq_way'), // 검증방식1
                'vrfc_type_sub' => $this->request->getGet('vrfc_type_sub'), // 검증방식2
                'rcpt_cpid' => $this->request->getGet('rcpt_cpid'), // 매체사
                'rlet_type_cd' => $this->request->getGet('rlet_type_cd'), // 매물종류
                'status' => $this->request->getGet('status'), // 전송여부
            ];

            $datas = $this->model->getExcelList($data);

            return $this->response->setJSON(body: [
                'data' => $datas,
            ]);
        } catch (\Exception $e) {
            $e->getPrevious()->getTraceAsString();
        }
    }


    // 전송 api
    public function sendApi()
    {
        try {

            $type = $this->request->getPost('type');

            $this->model->updateSendApi($type);

            return $this->response->setJSON([
                'code' => '0',
                'msg' => 'success',
            ]);

        } catch (\Exception $e) {
            return $this->response->setJSON([
                'code' => '9',
                'msg' => $e->getMessage(),
            ]);
        }
    }
}